﻿using System;
//using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using Unit4.CollectionsLib;
namespace FileReader
{
    public class Class1
    {
        public class FileReader
        {
            private StreamReader reader;
           // * Constructs a new FileReader that reads values from the specified file.
          //* @param pathname - pathname string of the file.
    
 
            public FileReader(string pathName)
            {
                try
                {
                    reader = new StreamReader(pathName);
                }

                catch (IOException ex)
                {
                    Console.Write(ex.Message);
                }

            }

            //* Closes the FileReader
 
            public void Close()
            {
                reader.Close();
            }
            //* Read int value from the file.
           //  @return int value read from the file
     
            public int ReadInt()
            {
                return (int.Parse(reader.ReadLine()));

            }
            //Read double value from the file.
            // @return double value read from the file
    
            public double ReadDouble()
            {
                return (double.Parse(reader.ReadLine()));

            }
            //Read boolean value from the file.
            // @return boolean value read from the file
            public bool ReadBool()
            {
                return (bool.Parse(reader.ReadLine()));

            }
            //Read string value from the file.
            // @return string value read from the file
            public string ReadString()
            {
                return (reader.ReadLine());
            }
            //Read char value from the file.
            // @return char value read from the file
            public char ReadChar()
            {
                return (char.Parse(reader.ReadLine()));
            }
            //Read array of int values from the file.
            // @return array of int values read from the file
 
            public int[] ReadIntArray()
            {
                List<int> l = new List<int>();
                string s = reader.ReadLine();
                int a, count = 0;

                Node<int> pos = null;

                while (s != "]")
                {
                    s = reader.ReadLine();
                    if (s != "]")
                    {
                        a = int.Parse(s);
                        count++;
                        pos = l.Insert(pos, a);
                    }


                }

                int[] arr = new int[count];
                int i = 0;

                pos = l.GetFirst();
                while (pos != null)
                {
                    arr[i] = pos.GetInfo();
                    //Console.WriteLine(" "+  arr[i]);
                    pos = pos.GetNext();
                    i++;
                }

                return arr;

            }
            //Read matrix of int values from the file.
            // @return matrix of int values read from the file
            public int[,] ReadIntMatrix()
            {
                List<List<int>> l = new List<List<int>>();
                string s = reader.ReadLine();
                s = reader.ReadLine();
                int a, count = 0, count1 = 0;

                Node<List<int>> pos = null;
                Node<int> pos1 = null;
                List<int> temp;
                while (s != "]")
                {
                    temp = new List<int>();
                    pos1 = null;
                    count1 = 0;

                    while (s != "]")
                    {

                        s = reader.ReadLine();
                        if (s != "]")
                        {
                            a = int.Parse(s);
                            count1++;
                            pos1 = temp.Insert(pos1, a);
                        }

                    }
                    count++;

                    s = reader.ReadLine();
                    pos = l.Insert(pos, temp);

                }

                int[,] arr = new int[count, count1];
                int i = 0, j = 0;

                pos = l.GetFirst();

                while (pos != null)
                {
                    j = 0;
                    pos1 = pos.GetInfo().GetFirst();
                    while (pos1 != null)
                    {
                        arr[i, j] = pos1.GetInfo();
                        pos1 = pos1.GetNext();
                        //Console.WriteLine(" " + arr[i,j]);
                        j++;
                    }
                    pos = pos.GetNext();
                    i++;
                }

                return arr;

            }
            //Read array of double values from the file.
            // @return array of double values read from the file
            public double[] ReadDoubleArray()
            {
                List<double> l = new List<double>();
                string s = reader.ReadLine();
                double a;
                int count = 0;

                Node<double> pos = null;

                while (s != "]")
                {
                    s = reader.ReadLine();
                    if (s != "]")
                    {
                        a = double.Parse(s);
                        count++;
                        pos = l.Insert(pos, a);
                    }

                }

                double[] arr = new double[count];
                int i = 0;

                pos = l.GetFirst();
                while (pos != null)
                {
                    arr[i] = pos.GetInfo();
                    //Console.WriteLine(" " + arr[i]);
                    pos = pos.GetNext();
                    i++;
                }

                return arr;

            }
            //Read array of string values from the file.
            // @return array of string values read from the file
            public string[] ReadStringArray()
            {
                List<string> l = new List<string>();
                string s = reader.ReadLine();
                int count = 0;

                Node<string> pos = null;

                while (s != "]")
                {
                    s = reader.ReadLine();
                    if (s != "]")
                    {
                        count++;
                        pos = l.Insert(pos, s);
                    }

                }

                string[] arr = new string[count];
                int i = 0;

                pos = l.GetFirst();
                while (pos != null)
                {
                    arr[i] = pos.GetInfo();
                    //Console.WriteLine(" " + arr[i]);
                    pos = pos.GetNext();
                    i++;
                }

                return arr;

            }



        }
    }
}
