﻿using System;
//using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using Unit4.CollectionsLib;

namespace FileWriter
{
    public class Class1
    {
        public class FileWriter
        {

            private StreamWriter writer;
            //Constructs a new FileWriter that writes values to the specified file.

            public FileWriter(string pathName)
            {
                try
                {
                    writer = new StreamWriter(pathName);
                }

                catch (IOException ex)
                {
                    Console.Write(ex.Message);
                }

            }
            //Closes the FileWriter

            public void Close()
            {
                writer.Close();
            }
            //Write int value to the file.
            // @param value - int value to be written to the file
 
            public void IntWriting(int data)
            {
                try
                {

                    writer.WriteLine(data);
                    writer.Flush();
                }

                catch (IOException ex)
                {
                    Console.Write(ex.Message);

                }

            }
            //Write double value to the file.
            // @param value - double value to be written to the file
            public void DoubleWriting(double data)
            {
                try
                {

                    writer.WriteLine(data);
                    writer.Flush();
                }

                catch (IOException ex)
                {
                    Console.Write(ex.Message);

                }

            }
            //Write char value to the file.
            // @param value - char value to be written to the file
            public void CharWriting(char data)
            {
                try
                {

                    writer.WriteLine(data);
                    writer.Flush();
                }

                catch (IOException ex)
                {
                    Console.Write(ex.Message);

                }

            }
            //Write string value to the file.
            // @param value - string value to be written to the file
            public void StringWriting(string data)
            {
                try
                {

                    writer.WriteLine(data);
                    writer.Flush();
                }

                catch (IOException ex)
                {
                    Console.Write(ex.Message);

                }

            }
            //Write boolean value to the file.
            // @param value - boolean value to be written to the file
            public void BoolWriting(bool data)
            {
                try
                {

                    writer.WriteLine(data);
                    writer.Flush();
                }

                catch (IOException ex)
                {
                    Console.Write(ex.Message);

                }



            }
            //Write array of int values to the file.
            // @param arr - array of int values value to be written to the file
  
            public void IntArrayWriting(int[] data)
            {
                try
                {
                    writer.WriteLine('[');
                    for (int i = 0; i < data.Length; i++)
                    {
                        writer.WriteLine(data[i]);
                    }
                    writer.WriteLine(']');
                    writer.Flush();
                }
                catch (IOException ex)
                {
                    Console.Write(ex.Message);

                }

            }
            //Write matrix of int values to the file.
            // @param mat - matrix of int values value to be written to the file
  
            public void IntMatrixWriting(int[,] mat)
            {
                try
                {
                    writer.WriteLine('[');

                    for (int i = 0; i < mat.GetLength(0); i++)
                    {
                        writer.WriteLine('[');
                        for (int j = 0; j < mat.GetLength(1); j++)
                            writer.WriteLine(mat[i, j]);
                        writer.WriteLine(']');
                    }
                    writer.WriteLine(']');
                    writer.Flush();
                }
                catch (IOException ex)
                {
                    Console.Write(ex.Message);

                }

            }
            //Write array of double values to the file.
            // @param arr - array of double values value to be written to the file
  
            public void DoubleArrayWriting(double[] data)
            {
                try
                {
                    writer.WriteLine('[');

                    for (int i = 0; i < data.Length; i++)
                    {
                        writer.WriteLine(data[i]);
                    }
                    writer.WriteLine(']');
                    writer.Flush();
                }
                catch (IOException ex)
                {
                    Console.Write(ex.Message);

                }

            }
            //Write array of string values to the file.
            // @param arr - array of string values value to be written to the file
  
            public void StringArrayWriting(string[] data)
            {
                try
                {
                    writer.WriteLine('[');
                    for (int i = 0; i < data.Length; i++)
                    {
                        writer.WriteLine(data[i]);
                    }
                    writer.WriteLine(']');
                    writer.Flush();
                }
                catch (IOException ex)
                {
                    Console.Write(ex.Message);

                }
            }


        }
             

    }
}
